//
//  PieProgressView.swift
//  FromWatchToCircle
//
//  Created by 张海峰 on 2018/6/1.
//  Copyright © 2018年 张海峰. All rights reserved.
//
/*尊重OC原创作者：高少东 https://github.com/gsdios/SDProgressView.git */
/*写该demo的目的：主要是想从时钟开始，一步步窥见项目中和圆有关的东西，从而学习巩固，加深理解。
 (项目不定时更新，所以最好从下面地址获取最新demo),感觉我这个demo对你有启发或者帮助，欢迎fork 感谢star
 https://github.com/FighterLightning/FromWatchToCircle.git
 */
import UIKit
class PieProgressView: BaseProgressView {
    override func draw(_ rect: CGRect) {
        super.draw(rect)
        let ctx: CGContext = UIGraphicsGetCurrentContext()!
       // 背景圆
        UIColor.red.set()
        let radius :CGFloat = (defaultWH - ProgressViewItemMargin)/2//半径
        let WH: CGFloat  = radius * 2 + 4
        let x: CGFloat  = (defaultWH - WH)/2
        let y: CGFloat = (defaultWH - WH)/2
        ctx.addEllipse(in: CGRect.init(x: x, y: y, width: WH, height: WH))
        ctx.fillPath()
         // 进程圆
           let centerXY: CGFloat = defaultWH/2
        UIColor.yellow.set()// 进度条颜色
        ctx.move(to: CGPoint.init(x: centerXY, y: centerXY))
        ctx.addLine(to: CGPoint.init(x: centerXY, y: 0))
        let endAngle: CGFloat = self.progress * .pi*2 + CGFloat(-Double.pi/2) + 0.05 ; // 初始值0.05
        ctx.addArc(center: CGPoint.init(x: centerXY, y: centerXY), radius: radius, startAngle: -.pi/2, endAngle: endAngle, clockwise: true)
        ctx.closePath() //闭合路径，把起始点和终点连接起来
        ctx.fillPath()
        //显示进度数字
        //要绘制的文字
        let progressStr = "\(self.progress * 100)%"
        //文字样式属性
        let style = NSMutableParagraphStyle()
        style.alignment = .center
        let attributes = [NSAttributedStringKey.font: UIFont.systemFont(ofSize: defaultTextFont),
                          NSAttributedStringKey.foregroundColor: UIColor.gray,
                          NSAttributedStringKey.paragraphStyle: style]
        self.setCenterProgressText(text: progressStr, attributes: attributes)
    }
}
