//
//  TransparentPieProgressView.swift
//  FromWatchToCircle
//
//  Created by 张海峰 on 2018/6/1.
//  Copyright © 2018年 张海峰. All rights reserved.
//
/*尊重OC原创作者：高少东 https://github.com/gsdios/SDProgressView.git */
/*写该demo的目的：主要是想从时钟开始，一步步窥见项目中和圆有关的东西，从而学习巩固，加深理解。
 (项目不定时更新，所以最好从下面地址获取最新demo),感觉我这个demo对你有启发或者帮助，欢迎fork 感谢star
 https://github.com/FighterLightning/FromWatchToCircle.git
 */
import UIKit

class TransparentPieProgressView: BaseProgressView {
    override func draw(_ rect: CGRect) {
        super.draw(rect)
        let ctx: CGContext = UIGraphicsGetCurrentContext()!
        // 背景圆
        let centerXY: CGFloat = defaultWH/2
        let radius :CGFloat = centerXY - ProgressViewItemMargin
        UIColor.yellow.set()// 进度颜色
        ctx.addArc(center: CGPoint.init(x: centerXY, y: centerXY), radius: radius, startAngle:0 , endAngle: .pi * 2 , clockwise: true)
        ctx.fillPath()//实心的的
        // 进程圆
        UIColor.red.set()// 进度条颜色
        ctx.setLineWidth(1)
        ctx.move(to: CGPoint.init(x: centerXY, y: centerXY))
        ctx.addLine(to: CGPoint.init(x: centerXY, y: 0))
        let endAngle: CGFloat = self.progress * .pi*2 + CGFloat(-Double.pi/2) + 0.05 ; // 初始值0.05
        ctx.addArc(center: CGPoint.init(x: centerXY, y: centerXY), radius: radius, startAngle: -.pi/2, endAngle: endAngle, clockwise: true)
        ctx.closePath()
        ctx.fillPath()
    }
}
