//
//  ZHFAlertControllerTool.swift
//  ZHFToolBox
//
//  Created by 张海峰 on 2018/5/9.
//  Copyright © 2018年 张海峰. All rights reserved.
//
/*写该demo的目的：主要是想从时钟开始，一步步窥见项目中和圆有关的东西，从而学习巩固，加深理解。
 (项目不定时更新，所以最好从下面地址获取最新demo),感觉我这个demo对你有启发或者帮助，欢迎fork 感谢star
 https://github.com/FighterLightning/FromWatchToCircle.git
 */
import Foundation
import UIKit
/*
 - parameter currentVC: 当前控制器
 - parameter title:     标题
 - parameter meg:       提示消息
 - parameter cancelBtn: 取消按钮
 - parameter otherBtn:  其他按钮
 - parameter handler:   其他按钮处理事件
 */
class ZHFAlertControllerTool {
    /**
     alterController 一个按钮 不处理事件，简单实用
     */
    static func showAlert(currentVC:UIViewController, title:String,meg:String, cancelBtn:String){
        var title1 = ""
        if title == "" ||  title == nil  {
            title1 = "温馨提示"}
        else{
            title1 = title
        }
        let alertController = UIAlertController(title:title1,message:meg , preferredStyle: .alert)
        let cancelAction = UIAlertAction(title:cancelBtn, style: .cancel, handler:nil)
        alertController.addAction(cancelAction)
        currentVC.present(alertController, animated: true, completion: nil)
    }
    /**
     alterController 一个按钮 处理事件
     */
    static func showAlert(currentVC:UIViewController, title:String, meg:String, okBtn:String, handler:((UIAlertAction) -> Void)?){
        var title1 = ""
        if title == "" ||  title == nil  {
            title1 = "温馨提示"}
        else{
            title1 = title
        }
        let alertController = UIAlertController(title:title1,message:meg , preferredStyle: .alert)
        if okBtn != nil{
            let settingsAction = UIAlertAction(title: okBtn, style: .default, handler: { (action) -> Void in
                handler?(action)
            })
            alertController.addAction(settingsAction)
        }
        currentVC.present(alertController, animated: true, completion: nil)
    }
    /**
     两个按钮 都处理事件
     **/
    static func showAlert(currentVC:UIViewController, title:String, meg:String, oneBtn:String, otherBtn:String?,oneHandler:((UIAlertAction) -> Void)?, otherHandler:((UIAlertAction) -> Void)?){
        var title1 = ""
        if title == "" ||  title == nil  {
            title1 = "温馨提示"}
        else{
            title1 = title
        }
        let alertController = UIAlertController(title:title1,
                                                message:meg ,
                                                preferredStyle: .alert)
        let cancelAction = UIAlertAction(title:oneBtn, style: .cancel, handler:{ (action) -> Void in
            oneHandler?(action)
        })
        alertController.addAction(cancelAction)
        if otherBtn != nil{
            let settingsAction = UIAlertAction(title: otherBtn, style: .default, handler: { (action) -> Void in
                otherHandler?(action)
            })
            alertController.addAction(settingsAction)
        }
        currentVC.present(alertController, animated: true, completion: nil)
    }
}
